<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 https://maven.apache.org/xsd/maven-4.0.0.xsd">
  <modelVersion>4.0.0</modelVersion>
  <groupId>com.hsbc.assignment</groupId>
  <artifactId>rest-api-framework</artifactId>
  <version>0.0.1-SNAPSHOT</version>
  
  <reporting>
        <plugins>
            <plugin>
                <groupId>org.jacoco</groupId>
                <artifactId>jacoco-maven-plugin</artifactId>
                <reportSets>
                    <reportSet>
                        <reports>
                            <report>report</report>
                        </reports>
                      
                    </reportSet>
                </reportSets>
                <version>0.8.4</version>
               
            </plugin>
        </plugins>
    </reporting>
   <dependencies>
		<dependency>
    		<groupId>org.seleniumhq.selenium</groupId>
    		<artifactId>selenium-java</artifactId>
    		<version>4.0.0-alpha-5</version>
		</dependency>
	<!-- https://mvnrepository.com/artifact/io.github.bonigarcia/webdrivermanager -->
		<dependency>
    		<groupId>io.github.bonigarcia</groupId>
    		<artifactId>webdrivermanager</artifactId>
    		<version>3.8.1</version>
		</dependency>
		<dependency>
    		<groupId>io.rest-assured</groupId>
    		<artifactId>rest-assured</artifactId>
    		<version>4.3.0</version>
    		<scope>test</scope>
		</dependency>
		<!-- https://mvnrepository.com/artifact/io.rest-assured/json-schema-validator -->
		<dependency>
    		<groupId>io.rest-assured</groupId>
    		<artifactId>json-schema-validator</artifactId>
    		<version>4.3.0</version>
		</dependency>
		<dependency>
 			<groupId>com.vimalselvam</groupId>
 			<artifactId>cucumber-extentsreport</artifactId>
 			<version>3.0.2</version>
		</dependency>
		<dependency>
 			<groupId>com.aventstack</groupId>
 			<artifactId>extentreports</artifactId>
 			<version>5.0.4</version>
		</dependency>
		<dependency>
			<groupId>com.github.mkolisnyk</groupId>
			<artifactId>cucumber-reports</artifactId>
			<version>1.3.3</version>
			<type>pom</type>
		</dependency>
		<!-- https://mvnrepository.com/artifact/log4j/log4j -->
		<dependency>
    		<groupId>log4j</groupId>
    		<artifactId>log4j</artifactId>
    		<version>1.2.17</version>
		</dependency>
   		<dependency>
    		<groupId>com.fasterxml.jackson.core</groupId>
    		<artifactId>jackson-core</artifactId>
    		<version>2.10.3</version>
		</dependency>
		<!-- https://mvnrepository.com/artifact/io.cucumber/gherkin -->
		<dependency>
    		<groupId>io.cucumber</groupId>
    		<artifactId>gherkin</artifactId>
    		<version>4.1.3</version>
		</dependency>
		<dependency>
     		<groupId>junit</groupId>
    		<artifactId>junit</artifactId>
      		<version>4.12</version>
      		<scope>test</scope>
       </dependency>
        <dependency>
			<groupId>io.cucumber</groupId>
			<artifactId>cucumber-jvm-deps</artifactId>
			<version>1.0.6</version>
			<scope>test</scope>
		</dependency>
		<!-- https://mvnrepository.com/artifact/io.cucumber/cucumber-java -->
		<dependency>
			<groupId>io.cucumber</groupId>
			<artifactId>cucumber-java</artifactId>
			<version>5.6.0</version>
		</dependency>

		<!-- https://mvnrepository.com/artifact/io.cucumber/cucumber-core -->
		<dependency>
			<groupId>io.cucumber</groupId>
			<artifactId>cucumber-core</artifactId>
			<version>5.6.0</version>
		</dependency>
		<!-- https://mvnrepository.com/artifact/io.cucumber/cucumber-jvm -->
		<dependency>
			<groupId>io.cucumber</groupId>
			<artifactId>cucumber-jvm</artifactId>
			<version>5.6.0</version>
			<type>pom</type>
		</dependency>
		<dependency>
			<groupId>io.cucumber</groupId>
			<artifactId>cucumber-testng</artifactId>
			<version>5.6.0</version>
		</dependency>
		<!-- https://mvnrepository.com/artifact/io.cucumber/cucumber-junit -->
		<dependency>
			<groupId>io.cucumber</groupId>
			<artifactId>cucumber-junit</artifactId>
			<version>5.6.0</version>
			<!-- <scope>test</scope> -->
		</dependency>
        <dependency>
            <groupId>org.testng</groupId>
            <artifactId>testng</artifactId>
            <version>6.8.8</version>
            <scope>test</scope>
        </dependency>
        <dependency>
     		<groupId>tech.grasshopper</groupId>
    		<artifactId>extentreports-cucumber5-adapter</artifactId>
      		<version>2.3.0</version>
      		<exclusions>
      			<exclusion>
      				<groupId>
      					com.github.ralfstuckert.pdfbox-layout
      				</groupId>
      				<artifactId>pdfbox2-layout</artifactId>
      			</exclusion>
      			<exclusion>
      				<groupId>org.apache.pdfbox</groupId>
      				<artifactId>pdfbox</artifactId>
      			</exclusion>
      		</exclusions>
        </dependency>
       <dependency>
     		<groupId>org.apache.poi</groupId>
    		<artifactId>poi</artifactId>
      		<version>3.17</version>
       </dependency>
       <dependency>
     		<groupId>org.apache.poi</groupId>
    		<artifactId>poi-ooxml</artifactId>
      		<version>3.17</version>
       </dependency>
       <dependency>
     		<groupId>org.apache.poi</groupId>
    		<artifactId>poi-ooxml-schemas</artifactId>
      		<version>3.17</version>
       </dependency>
        <dependency>
            <groupId>net.masterthought</groupId>
            <artifactId>cucumber-reporting</artifactId>
            <version>3.8.0</version>
        </dependency> 
	<!-- https://mvnrepository.com/artifact/com.github.ralfstuckert.pdfbox-layout/pdfbox2-layout -->
        
    </dependencies>
    <build>
  
	  <plugins>
	  <plugin>
	   <groupId>org.codehaus.mojo</groupId>
	   <artifactId>findbugs-maven-plugin</artifactId>
	   <version>3.0.5</version>
	   <configuration>
	   	  <encoding>UTF-8</encoding>
	   	  <effort>Max</effort>
	      <includeTests>true</includeTests>
	      <classFilesDirectory>${project.build.testOutputDirectory}</classFilesDirectory>
	       <threshold>Low</threshold>
	       <outputDirectory>${project.build.directory}/findbugs</outputDirectory>
	       <outputEncoding>UTF-8</outputEncoding>
	       <failOnError>false</failOnError>
            <xmlOutput>true</xmlOutput>
             <findbugsXmlOutputDirectory>${project.build.directory}/findbugs</findbugsXmlOutputDirectory>
 
	   </configuration>
	  <executions>
	  	  
		  <execution>
		  
		   <phase>test</phase>
		   <goals>
		    <goal>findbugs</goal>
		
		   </goals>
		  </execution>
		 </executions>
	  </plugin>
	
		<plugin>
        <groupId>org.codehaus.mojo</groupId>
        <artifactId>xml-maven-plugin</artifactId>
        <version>1.0.2</version>
        
        <executions>
            <execution>
            	<phase>test</phase>
                <goals>
                    <goal>transform</goal>
                </goals>
            </execution>
        </executions>
        <configuration>
        	<encoding>UTF-8</encoding>
        	
            <transformationSets>
                <transformationSet>
                    <dir>${project.build.directory}/findbugs</dir>
                    <outputDir>${project.build.directory}/findbugs</outputDir>
                    <stylesheet>summary.xsl</stylesheet>
                    <!--<stylesheet>default.xsl</stylesheet>-->
                    <!--<stylesheet>plain.xsl</stylesheet>-->
                    <!--<stylesheet>fancy.xsl</stylesheet>-->
                    <!--<stylesheet>summary.xsl</stylesheet>-->
                    <fileMappers>
                        <fileMapper
                                implementation="org.codehaus.plexus.components.io.filemappers.FileExtensionMapper">
                            <targetExtension>.html</targetExtension>
                        </fileMapper>
                    </fileMappers>
                </transformationSet>
            </transformationSets>
        </configuration>
        <dependencies>
            <dependency>
                <groupId>com.google.code.findbugs</groupId>
                <artifactId>findbugs</artifactId>
                <version>2.0.1</version>
            </dependency>
        </dependencies>
    </plugin>
      
        	 <plugin>
        		<groupId>org.apache.maven.plugins</groupId>
        		<artifactId>maven-compiler-plugin</artifactId>
        		<version>3.8.1</version>
        		<configuration>
          			<source>1.8</source>
          			<target>1.8</target>
        		</configuration>
       
      		</plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>3.0.0-M5</version>
                <configuration>
				<additionalClasspathElements>
                    <additionalClasspathElement>src/test/java/</additionalClasspathElement>
                </additionalClasspathElements>
                    <suiteXmlFiles>
                        <suiteXmlFile>testng.xml</suiteXmlFile>
                    </suiteXmlFiles>
                    <parallel>tests</parallel>
        			<useUnlimitedThreads>true</useUnlimitedThreads>
        			<!-- <properties>
        			<property>
            			<name>dataproviderthreadcount</name>
            			<value>20</value>
        				</property>
    			</properties> -->
    			<systemPropertyVariables>
    					<extent.reporter.spark.start>true</extent.reporter.spark.start>
    					<extent.reporter.spark.out>test-output/SparkReport/Spark.html</extent.reporter.spark.out>
                     <!--   <jacoco-agent.destfile>target/jacoco.exec</jacoco-agent.destfile> -->
                   </systemPropertyVariables>
                </configuration>
            </plugin>
            <plugin>
                <groupId>net.masterthought</groupId>
                <artifactId>maven-cucumber-reporting</artifactId>
                <version>3.8.0</version>
                <executions>
                    <execution>
                        <id>execution</id>
                        <phase>test</phase>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <configuration>
                            <projectName>HSBC_RestAssured_Assignment</projectName>
                            <outputDirectory>${project.build.directory}/cucumber-reports/cucumber-pretty</outputDirectory>
                          	<cucumberOutput>${project.build.directory}/cucumber-reports/cucumber.json</cucumberOutput>
                           <!--  <buildNumber>1</buildNumber>
                            <parallelTesting></parallelTesting> -->
                        </configuration>
                    </execution>
                </executions>
            </plugin>

    <plugin>
      <groupId>org.jacoco</groupId>
      <artifactId>jacoco-maven-plugin</artifactId>
      <version>0.8.4</version>
      
      <configuration>
		<includes><include>**/*assignment.*</include></includes>
   		<destFile>${project.build.directory}/jacoco.exec</destFile>
      	<classDumpDir>${project.build.outputDirectory}</classDumpDir>
      	<dataFile>${project.build.directory}/jacoco.exec</dataFile>
         <outputDirectory>${project.reporting.outputDirectory}/jacoco</outputDirectory>                 
                      
      </configuration>
                <executions>
                    <execution>
                    <phase>initialize</phase>
                        <goals>
                            <goal>prepare-agent</goal>
                        </goals>
                    </execution>
                   <!--  <execution>
                    		<id>jacoco-check</id>
							<phase>test</phase>
							<goals>
								<goal>check</goal>
							</goals>
							<configuration>
								<rules>
									<rule implementation="org.jacoco.maven.RuleConfiguration">
										<element>BUNDLE</element>
										<includes><include>**/*assignment.*</include></includes>
										<limits>
											<limit implementation="org.jacoco.report.check.Limit">
												<counter>INSTRUCTION</counter>
												<value>COVEREDRATIO</value>
												<minimum>0.60</minimum>
											</limit>
										</limits>
									</rule>
								</rules>
										<includes><include>**/*assignment.*</include></includes>
										
										<dataFile>${project.build.directory}/jacoco.exec</dataFile>
								
								</configuration>
                    </execution> -->
                </executions>
          
    </plugin>
<plugin>
	<groupId>org.codehaus.mojo</groupId>
	<artifactId>build-helper-maven-plugin</artifactId>
	<version>1.12</version>
</plugin>
	<plugin>
	<groupId>org.apache.maven.plugins</groupId>
	<artifactId>maven-site-plugin</artifactId>
	<version>3.9.1</version>
	</plugin>
		<plugin>
	<groupId>org.apache.maven.plugins</groupId>
	<artifactId>maven-project-info-reports-plugin</artifactId>
	<version>3.1.0</version>
	</plugin>
        </plugins>
    </build>
</project>